/*
	(C) 2011. Kruchinin Aleksandr. http://vidikon.com
	Management.cpp
	1.00
*/
#include "GetPutData.h"
#include <stdio.h>
#include <stdlib.h>

#define MAX_SIZE	0x10000

HANDLE Mutex1;
int mode=1; // Data mode
bool stop=0;

int M_DataTime=500; // Main time param
long M_DataSize=100;
bool display=0;

// Memory
HANDLE hMapping;
char* lpData;

void GenerateData();

DWORD WINAPI M_Data(LPVOID)
{
	// Creation of memory
	
	// Creating or opening an existing file of the projection
	hMapping = CreateFileMapping( (HANDLE)(-1)/*Page file*/, NULL, PAGE_READWRITE, 0, MAX_SIZE, "M_Data_Page");
	if (hMapping == NULL) return 1;

	// Placing the projection hMapping in the address space of our process, lpData gets the address location
	lpData = (char*) MapViewOfFile(hMapping,  FILE_MAP_READ | FILE_MAP_WRITE,0,0,0);
	if (lpData == NULL) return 1;

	// Wait Run	
	Mutex1=OpenMutex(SYNCHRONIZE,true,"Mutex_Data");
	WaitForSingleObject(Mutex1,INFINITE);
	printf("Run Data module with dt=%dms; size=%d...\n",M_DataTime,M_DataSize);
	
		
	HANDLE Mutex_Recog_D=0;		
	HANDLE Mutex_Control_D=0;	
	HANDLE Mutex_Control=0;	
	HANDLE Mutex1;
	Mutex_Recog_D=CreateMutex(NULL,true,"Mutex_Recog_D");
	Mutex_Control_D=CreateMutex(NULL,true,"Mutex_Control_D");
	Mutex_Control=CreateMutex(NULL,true,"Mutex_Control");
	ReleaseMutex(Mutex_Control_D);
	do{
		// Critical region			
		GenerateData();		
		// Out critical region				
		if (display) printf("Generate data\n");			
		WaitForSingleObject(Mutex_Control_D,1);		
		ReleaseMutex(Mutex_Recog_D);		
		ReleaseMutex(Mutex_Control);		
		Sleep(M_DataTime);
		if (stop) break;	
		Mutex1=OpenMutex(SYNCHRONIZE,true,"Mutex_Data2");
		WaitForSingleObject(Mutex1,INFINITE);
		ReleaseMutex(Mutex1);
		WaitForSingleObject(Mutex_Recog_D,1);
		WaitForSingleObject(Mutex_Control,1);
		ReleaseMutex(Mutex_Control_D);				
	}while(1);
	
	UnmapViewOfFile( ( LPCVOID )lpData );
	CloseHandle( hMapping );
	return 0;
}

void CloseMemoryData()
{
	// Free memory
	stop=1;
	UnmapViewOfFile(lpData);
	CloseHandle(hMapping);
}

void SetM_DataTime(int time)
{
	M_DataTime=time;
}

void SetM_DataSize(long size)
{
	M_DataSize=size;
}

void GenerateData()
{
	int all=10;
	int i,j;

	Sleep(10);

	// Zero memory
	memset(lpData,0,M_DataSize);
	for(i=0;i<all;i++)
	{
		do{
			j=int(M_DataSize*(double)rand()/RAND_MAX+0.5);
		}
		while(lpData[j]!=0);
		lpData[j]=1;
	}
}

void SetM_DataDisplay()
{
	if (display==1) display=0;
	else display=1;
}